nanobsd boot problem
Jack Mc Lauren
jack.mclauren at yahoo.com
Wed Nov 7 14:42:36 UTC 2012
Thanks for your reply ...
>>Pls. post the .conf file you used to build NanoBSD.
this is the whole nanobsd.sh file. sorry it's a bit long ...
###################################################################################################################################
set -e
# Name of this NanoBSD build. (Used to construct workdir names)
NANO_NAME=full
# Source tree directory
NANO_SRC=/usr/src
# Where nanobsd additional files live under the source tree
NANO_TOOLS=tools/tools/nanobsd
# Where cust_pkg() finds packages to install
NANO_PACKAGE_DIR=${NANO_SRC}/${NANO_TOOLS}/Pkg
NANO_PACKAGE_LIST="*"
# Object tree directory
# default is subdir of /usr/obj
NANO_OBJ="/var/images"
# The directory to put the final images
# default is ${NANO_OBJ}
#NANO_DISKIMGDIR=""
# Parallel Make
NANO_PMAKE="make -j 3"
# The default name for any image we create.
NANO_IMGNAME="_.disk.full"
# Options to put in make.conf during buildworld only
CONF_BUILD='
WITHOUT_ACCT="YES"
WITHOUT_AMD="YES"
WITHOUT_APM="YES"
WITHOUT_ASSERT_DEBUG="YES"
WITHOUT_ATM="YES"
WITHOUT_AUDIT="YES"
WITHOUT_AUTHPF="YES"
WITHOUT_BIND="YES"
WITHOUT_BIND_DNSSEC="YES"
WITHOUT_BIND_ETC="YES"
WITHOUT_BIND_LIBS_LWRES="YES"
WITHOUT_BIND_MTREE="YES"
WITHOUT_BIND_NAMED="YES"
WITHOUT_BIND_UTILS="YES"
WITHOUT_BLUETOOTH="YES"
WITHOUT_BSNMP="YES"
WITHOUT_CALENDAR="YES"
WITHOUT_CAPSICUM="YES"
WITHOUT_CTM="YES"
WITHOUT_CVS="YES"
WITHOUT_DICT="YES"
WITHOUT_EXAMPLES="YES"
WITHOUT_FLOPPY="YES"
WITHOUT_FREEBSD_UPDATE="YES"
WITHOUT_GAMES="YES"
WITHOUT_GCOV="YES"
WITHOUT_GDB="YES"
WITHOUT_GPIB="YES"
WITHOUT_GPIO="YES"
WITHOUT_HTML="YES"
WITHOUT_IPFILTER="YES"
WITHOUT_IPX="YES"
WITHOUT_IPX_SUPPORT="YES"
WITHOUT_JAIL="YES"
WITHOUT_KERBEROS="YES"
WITHOUT_KERBEROS_SUPPORT="YES"
WITHOUT_LIB32="YES"
WITHOUT_LOCALES="YES"
WITHOUT_LOCATE="YES"
WITHOUT_LPR="YES"
WITHOUT_MAN="YES"
WITHOUT_MAN_UTILS="YES"
WITHOUT_NCP="YES"
WITHOUT_NDIS="YES"
WITHOUT_NETCAT="YES"
WITHOUT_NIS="YES"
WITHOUT_NLS="YES"
WITHOUT_NLS_CATALOGS="YES"
WITHOUT_NS_CACHING="YES"
WITHOUT_PORTSNAP="YES"
WITHOUT_PROFILE="YES"
WITHOUT_QUOTAS="YES"
WITHOUT_RCMDS="YES"
WITHOUT_RESCUE="YES"
WITHOUT_ROUTED="YES"
WITHOUT_SENDMAIL="YES"
WITHOUT_SHAREDOCS="YES"
WITHOUT_SYSINSTALL="YES"
WITHOUT_WIRELESS="YES"
WITHOUT_WIRELESS_SUPPORT="YES"
WITHOUT_WPA_SUPPLICANT_EAPOL="YES"
WITHOUT_ZFS="YES"
WITH_IDEA="YES"
'
# Options to put in make.conf during installworld only
CONF_INSTALL='
WITHOUT_ACCT="YES"
WITHOUT_AMD="YES"
WITHOUT_APM="YES"
WITHOUT_ASSERT_DEBUG="YES"
WITHOUT_ATM="YES"
WITHOUT_AUDIT="YES"
WITHOUT_AUTHPF="YES"
WITHOUT_BIND="YES"
WITHOUT_BIND_DNSSEC="YES"
WITHOUT_BIND_ETC="YES"
WITHOUT_BIND_LIBS_LWRES="YES"
WITHOUT_BIND_MTREE="YES"
WITHOUT_BIND_NAMED="YES"
WITHOUT_BIND_UTILS="YES"
WITHOUT_BLUETOOTH="YES"
WITHOUT_BSNMP="YES"
WITHOUT_CALENDAR="YES"
WITHOUT_CAPSICUM="YES"
WITHOUT_CTM="YES"
WITHOUT_CVS="YES"
WITHOUT_DICT="YES"
WITHOUT_EXAMPLES="YES"
WITHOUT_FLOPPY="YES"
WITHOUT_FREEBSD_UPDATE="YES"
WITHOUT_GAMES="YES"
WITHOUT_GCOV="YES"
WITHOUT_GDB="YES"
WITHOUT_GPIB="YES"
WITHOUT_GPIO="YES"
WITHOUT_HTML="YES"
WITHOUT_IPFILTER="YES"
WITHOUT_IPX="YES"
WITHOUT_IPX_SUPPORT="YES"
WITHOUT_JAIL="YES"
WITHOUT_KERBEROS="YES"
WITHOUT_KERBEROS_SUPPORT="YES"
WITHOUT_LIB32="YES"
WITHOUT_LOCALES="YES"
WITHOUT_LOCATE="YES"
WITHOUT_LPR="YES"
WITHOUT_MAN="YES"
WITHOUT_MAN_UTILS="YES"
WITHOUT_NCP="YES"
WITHOUT_NDIS="YES"
WITHOUT_NETCAT="YES"
WITHOUT_NIS="YES"
WITHOUT_NLS="YES"
WITHOUT_NLS_CATALOGS="YES"
WITHOUT_NS_CACHING="YES"
WITHOUT_PORTSNAP="YES"
WITHOUT_PROFILE="YES"
WITHOUT_QUOTAS="YES"
WITHOUT_RCMDS="YES"
WITHOUT_RESCUE="YES"
WITHOUT_ROUTED="YES"
WITHOUT_SENDMAIL="YES"
WITHOUT_SHAREDOCS="YES"
WITHOUT_SYSINSTALL="YES"
WITHOUT_WIRELESS="YES"
WITHOUT_WIRELESS_SUPPORT="YES"
WITHOUT_WPA_SUPPLICANT_EAPOL="YES"
WITHOUT_ZFS="YES"
WITH_IDEA="YES"
'
# Options to put in make.conf during both build- & installworld.
CONF_WORLD='
WITHOUT_ACCT="YES"
WITHOUT_AMD="YES"
WITHOUT_APM="YES"
WITHOUT_ASSERT_DEBUG="YES"
WITHOUT_ATM="YES"
WITHOUT_AUDIT="YES"
WITHOUT_AUTHPF="YES"
WITHOUT_BIND="YES"
WITHOUT_BIND_DNSSEC="YES"
WITHOUT_BIND_ETC="YES"
WITHOUT_BIND_LIBS_LWRES="YES"
WITHOUT_BIND_MTREE="YES"
WITHOUT_BIND_NAMED="YES"
WITHOUT_BIND_UTILS="YES"
WITHOUT_BLUETOOTH="YES"
WITHOUT_BSNMP="YES"
WITHOUT_CALENDAR="YES"
WITHOUT_CAPSICUM="YES"
WITHOUT_CTM="YES"
WITHOUT_CVS="YES"
WITHOUT_DICT="YES"
WITHOUT_EXAMPLES="YES"
WITHOUT_FLOPPY="YES"
WITHOUT_FREEBSD_UPDATE="YES"
WITHOUT_GAMES="YES"
WITHOUT_GCOV="YES"
WITHOUT_GDB="YES"
WITHOUT_GPIB="YES"
WITHOUT_GPIO="YES"
WITHOUT_HTML="YES"
WITHOUT_IPFILTER="YES"
WITHOUT_IPX="YES"
WITHOUT_IPX_SUPPORT="YES"
WITHOUT_JAIL="YES"
WITHOUT_KERBEROS="YES"
WITHOUT_KERBEROS_SUPPORT="YES"
WITHOUT_LIB32="YES"
WITHOUT_LOCALES="YES"
WITHOUT_LOCATE="YES"
WITHOUT_LPR="YES"
WITHOUT_MAN="YES"
WITHOUT_MAN_UTILS="YES"
WITHOUT_NCP="YES"
WITHOUT_NDIS="YES"
WITHOUT_NETCAT="YES"
WITHOUT_NIS="YES"
WITHOUT_NLS="YES"
WITHOUT_NLS_CATALOGS="YES"
WITHOUT_NS_CACHING="YES"
WITHOUT_PORTSNAP="YES"
WITHOUT_PROFILE="YES"
WITHOUT_QUOTAS="YES"
WITHOUT_RCMDS="YES"
WITHOUT_RESCUE="YES"
WITHOUT_ROUTED="YES"
WITHOUT_SENDMAIL="YES"
WITHOUT_SHAREDOCS="YES"
WITHOUT_SYSINSTALL="YES"
WITHOUT_WIRELESS="YES"
WITHOUT_WIRELESS_SUPPORT="YES"
WITHOUT_WPA_SUPPLICANT_EAPOL="YES"
WITHOUT_ZFS="YES"
WITH_IDEA="YES"
'
# Kernel config file to use
NANO_KERNEL=GENERIC
# Customize commands.
NANO_CUSTOMIZE=""
#cust_clean
# Late customize commands.
NANO_LATE_CUSTOMIZE=""
# Newfs paramters to use
NANO_NEWFS="-b 4096 -f 512 -i 8192 -O1 -U"
# The drive name of the media at runtime
NANO_DRIVE=da0
# Target media size in 512 bytes sectors
NANO_MEDIASIZE=600000
#UsbDevice generic-hdd 256
# Number of code images on media (1 or 2)
NANO_IMAGES=1
# 0 -> Leave second image all zeroes so it compresses better.
# 1 -> Initialize second image with a copy of the first
NANO_INIT_IMG2=0
# Size of code file system in 512 bytes sectors
# If zero, size will be as large as possible.
NANO_CODESIZE=0
# Size of configuration file system in 512 bytes sectors
# Cannot be zero.
NANO_CONFSIZE=20480
# Size of data file system in 512 bytes sectors
# If zero: no partition configured.
# If negative: max size possible
NANO_DATASIZE=20480
# Size of the /etc ramdisk in 512 bytes sectors
NANO_RAM_ETCSIZE=10240
# Size of the /tmp+/var ramdisk in 512 bytes sectors
NANO_RAM_TMPVARSIZE=20480
# Media geometry, only relevant if bios doesn't understand LBA.
NANO_SECTS=63
NANO_HEADS=255
# boot0 flags/options and configuration
NANO_BOOT0CFG="-o packet -s 1 -m 3"
NANO_BOOTLOADER="boot/boot0sio"
# boot2 flags/options
# default force serial console
NANO_BOOT2CFG="-h"
# Backing type of md(4) device
# Can be "file" or "swap"
NANO_MD_BACKING="file"
# Progress Print level
PPLEVEL=3
#######################################################################
# Architecture to build. Corresponds to TARGET_ARCH in a buildworld.
# Unfortunately, there's no way to set TARGET at this time, and it
# conflates the two, so architectures where TARGET != TARGET_ARCH do
# not work. This defaults to the arch of the current machine.
NANO_ARCH=`uname -p`
#######################################################################
#
# The functions which do the real work.
# Can be overridden from the config file(s)
#
#######################################################################
clean_build ( ) (
pprint 2 "Clean and create object directory (${MAKEOBJDIRPREFIX})"
if ! rm -rf ${MAKEOBJDIRPREFIX} > /dev/null 2>&1 ; then
chflags -R noschg ${MAKEOBJDIRPREFIX}
rm -r ${MAKEOBJDIRPREFIX}
fi
mkdir -p ${MAKEOBJDIRPREFIX}
printenv > ${MAKEOBJDIRPREFIX}/_.env
)
make_conf_build ( ) (
pprint 2 "Construct build make.conf ($NANO_MAKE_CONF_BUILD)"
echo "${CONF_WORLD}" > ${NANO_MAKE_CONF_BUILD}
echo "${CONF_BUILD}" >> ${NANO_MAKE_CONF_BUILD}
)
build_world ( ) (
pprint 2 "run buildworld"
pprint 3 "log: ${MAKEOBJDIRPREFIX}/_.bw"
cd ${NANO_SRC}
env TARGET_ARCH=${NANO_ARCH} ${NANO_PMAKE} \
__MAKE_CONF=${NANO_MAKE_CONF_BUILD} buildworld \
> ${MAKEOBJDIRPREFIX}/_.bw 2>&1
)
build_kernel ( ) (
pprint 2 "build kernel ($NANO_KERNEL)"
pprint 3 "log: ${MAKEOBJDIRPREFIX}/_.bk"
if [ -f ${NANO_KERNEL} ] ; then
cp ${NANO_KERNEL} ${NANO_SRC}/sys/${NANO_ARCH}/conf
fi
(cd ${NANO_SRC};
# unset these just in case to avoid compiler complaints
# when cross-building
unset TARGET_CPUTYPE
unset TARGET_BIG_ENDIAN
env TARGET_ARCH=${NANO_ARCH} ${NANO_PMAKE} buildkernel \
__MAKE_CONF=${NANO_MAKE_CONF_BUILD} KERNCONF=`basename ${NANO_KERNEL}` \
> ${MAKEOBJDIRPREFIX}/_.bk 2>&1
)
)
clean_world ( ) (
if [ "${NANO_OBJ}" != "${MAKEOBJDIRPREFIX}" ]; then
pprint 2 "Clean and create object directory (${NANO_OBJ})"
if ! rm -rf ${NANO_OBJ} > /dev/null 2>&1 ; then
chflags -R noschg ${NANO_OBJ}
rm -r ${NANO_OBJ}
fi
mkdir -p ${NANO_OBJ} ${NANO_WORLDDIR}
printenv > ${NANO_OBJ}/_.env
else
pprint 2 "Clean and create world directory (${NANO_WORLDDIR})"
if ! rm -rf ${NANO_WORLDDIR}/ > /dev/null 2>&1 ; then
chflags -R noschg ${NANO_WORLDDIR}
rm -rf ${NANO_WORLDDIR}
fi
mkdir -p ${NANO_WORLDDIR}
fi
)
make_conf_install ( ) (
pprint 2 "Construct install make.conf ($NANO_MAKE_CONF_INSTALL)"
echo "${CONF_WORLD}" > ${NANO_MAKE_CONF_INSTALL}
echo "${CONF_INSTALL}" >> ${NANO_MAKE_CONF_INSTALL}
)
install_world ( ) (
pprint 2 "installworld"
pprint 3 "log: ${NANO_OBJ}/_.iw"
cd ${NANO_SRC}
env TARGET_ARCH=${NANO_ARCH} \
${NANO_PMAKE} __MAKE_CONF=${NANO_MAKE_CONF_INSTALL} installworld \
DESTDIR=${NANO_WORLDDIR} \
> ${NANO_OBJ}/_.iw 2>&1
chflags -R noschg ${NANO_WORLDDIR}
#for i in ${FreeBSDProgramDirs}; do
# echo "==> $i"
# (cd $i && eval env ${mkenv} ${mkcmd} INSTALL=install NOINSTALLLIB=yes NO_INSTALLLIB=yes install)
# done
)
install_etc ( ) (
pprint 2 "install /etc"
pprint 3 "log: ${NANO_OBJ}/_.etc"
cd ${NANO_SRC}
env TARGET_ARCH=${NANO_ARCH} \
${NANO_PMAKE} __MAKE_CONF=${NANO_MAKE_CONF_INSTALL} distribution \
DESTDIR=${NANO_WORLDDIR} \
> ${NANO_OBJ}/_.etc 2>&1
# make.conf doesn't get created by default, but some ports need it
# so they can spam it.
cp /dev/null ${NANO_WORLDDIR}/etc/make.conf
)
install_kernel ( ) (
pprint 2 "install kernel"
pprint 3 "log: ${NANO_OBJ}/_.ik"
cd ${NANO_SRC}
env TARGET_ARCH=${NANO_ARCH} ${NANO_PMAKE} installkernel \
DESTDIR=${NANO_WORLDDIR} \
__MAKE_CONF=${NANO_MAKE_CONF_INSTALL} KERNCONF=`basename ${NANO_KERNEL}` \
> ${NANO_OBJ}/_.ik 2>&1
)
run_customize() (
pprint 2 "run customize scripts"
for c in $NANO_CUSTOMIZE
do
pprint 2 "customize \"$c\""
pprint 3 "log: ${NANO_OBJ}/_.cust.$c"
pprint 4 "`type $c`"
( $c ) > ${NANO_OBJ}/_.cust.$c 2>&1
done
)
run_late_customize() (
pprint 2 "run late customize scripts"
for c in $NANO_LATE_CUSTOMIZE
do
pprint 2 "late customize \"$c\""
pprint 3 "log: ${NANO_OBJ}/_.late_cust.$c"
pprint 4 "`type $c`"
( $c ) > ${NANO_OBJ}/_.late_cust.$c 2>&1
done
)
setup_nanobsd ( ) (
pprint 2 "configure nanobsd setup"
pprint 3 "log: ${NANO_OBJ}/_.dl"
(
cd ${NANO_WORLDDIR}
# Move /usr/local/etc to /etc/local so that the /cfg stuff
# can stomp on it. Otherwise packages like ipsec-tools which
# have hardcoded paths under ${prefix}/etc are not tweakable.
if [ -d usr/local/etc ] ; then
(
mkdir -p etc/local
cd usr/local/etc
find . -print | cpio -dumpl ../../../etc/local
cd ..
rm -rf etc
ln -s ../../etc/local etc
)
fi
for d in var etc
do
# link /$d under /conf
# we use hard links so we have them both places.
# the files in /$d will be hidden by the mount.
# XXX: configure /$d ramdisk size
mkdir -p conf/base/$d conf/default/$d
find $d -print | cpio -dumpl conf/base/
done
echo "$NANO_RAM_ETCSIZE" > conf/base/etc/md_size
echo "$NANO_RAM_TMPVARSIZE" > conf/base/var/md_size
# pick up config files from the special partition
echo "mount -o ro /dev/${NANO_DRIVE}s3" > conf/default/etc/remount
# Put /tmp on the /var ramdisk (could be symlink already)
rmdir tmp || true
rm tmp || true
ln -s var/tmp tmp
) > ${NANO_OBJ}/_.dl 2>&1
)
setup_nanobsd_etc ( ) (
pprint 2 "configure nanobsd /etc"
(
cd ${NANO_WORLDDIR}
# create diskless marker file
touch etc/diskless
# Make root filesystem R/O by default
echo "root_rw_mount=NO" >> etc/defaults/rc.conf
# save config file for scripts
echo "NANO_DRIVE=${NANO_DRIVE}" > etc/nanobsd.conf
echo "/dev/${NANO_DRIVE}s1a / ufs ro 1 1" > etc/fstab
echo "/dev/${NANO_DRIVE}s3 /cfg ufs rw,noauto 2 2" >> etc/fstab
mkdir -p cfg
)
)
prune_usr() (
# Remove all empty directories in /usr
find ${NANO_WORLDDIR}/usr -type d -depth -print |
while read d
do
rmdir $d > /dev/null 2>&1 || true
done
)
populate_slice ( ) (
local dev dir mnt
dev=$1
dir=$2
mnt=$3
test -z $2 && dir=/var/empty
test -d $d || dir=/var/empty
echo "Creating ${dev} with ${dir} (mounting on ${mnt})"
newfs ${NANO_NEWFS} ${dev}
mount ${dev} ${mnt}
cd ${dir}
find . -print | grep -Ev '/(CVS|\.svn)' | cpio -dumpv ${mnt}
df -i ${mnt}
umount ${mnt}
)
populate_cfg_slice ( ) (
populate_slice "$1" "$2" "$3"
)
populate_data_slice ( ) (
populate_slice "$1" "$2" "$3"
)
create_i386_diskimage ( ) (
pprint 2 "build diskimage"
pprint 3 "log: ${NANO_OBJ}/_.di"
(
echo $NANO_MEDIASIZE $NANO_IMAGES \
$NANO_SECTS $NANO_HEADS \
$NANO_CODESIZE $NANO_CONFSIZE $NANO_DATASIZE |
awk '
{
printf "# %s\n", $0
# size of cylinder in sectors
cs = $3 * $4
# number of full cylinders on media
cyl = int ($1 / cs)
# output fdisk geometry spec, truncate cyls to 1023
if (cyl <= 1023)
print "g c" cyl " h" $4 " s" $3
else
print "g c" 1023 " h" $4 " s" $3
if ($7 > 0) {
# size of data partition in full cylinders
dsl = int (($7 + cs - 1) / cs)
} else {
dsl = 0;
}
# size of config partition in full cylinders
csl = int (($6 + cs - 1) / cs)
if ($5 == 0) {
# size of image partition(s) in full cylinders
isl = int ((cyl - dsl - csl) / $2)
} else {
isl = int (($5 + cs - 1) / cs)
}
# First image partition start at second track
print "p 1 165 " $3, isl * cs - $3
c = isl * cs;
# Second image partition (if any) also starts offset one
# track to keep them identical.
if ($2 > 1) {
print "p 2 165 " $3 + c, isl * cs - $3
c += isl * cs;
}
# Config partition starts at cylinder boundary.
print "p 3 165 " c, csl * cs
c += csl * cs
# Data partition (if any) starts at cylinder boundary.
if ($7 > 0) {
print "p 4 165 " c, dsl * cs
} else if ($7 < 0 && $1 > c) {
print "p 4 165 " c, $1 - c
} else if ($1 < c) {
print "Disk space overcommitted by", \
c - $1, "sectors" > "/dev/stderr"
exit 2
}
# Force slice 1 to be marked active. This is necessary
# for booting the image from a USB device to work.
print "a 1"
}
' > ${NANO_OBJ}/_.fdisk
IMG=${NANO_DISKIMGDIR}/${NANO_IMGNAME}
MNT=${NANO_OBJ}/_.mnt
mkdir -p ${MNT}
if [ "${NANO_MD_BACKING}" = "swap" ] ; then
MD=`mdconfig -a -t swap -s ${NANO_MEDIASIZE} -x ${NANO_SECTS} \
-y ${NANO_HEADS}`
else
echo "Creating md backing file..."
dd if=/dev/zero of=${IMG} bs=${NANO_SECTS}b \
count=`expr ${NANO_MEDIASIZE} / ${NANO_SECTS}`
MD=`mdconfig -a -t vnode -f ${IMG} -x ${NANO_SECTS} \
-y ${NANO_HEADS}`
fi
trap "echo 'Running exit trap code' ; df -i ${MNT} ; umount ${MNT} || true ; mdconfig -d -u $MD" 1 2 15 EXIT
fdisk -i -f ${NANO_OBJ}/_.fdisk ${MD}
fdisk ${MD}
# XXX: params
# XXX: pick up cached boot* files, they may not be in image anymore.
boot0cfg -B -b ${NANO_WORLDDIR}/${NANO_BOOTLOADER} ${NANO_BOOT0CFG} ${MD}
bsdlabel -w -B -b ${NANO_WORLDDIR}/boot/boot ${MD}s1
bsdlabel ${MD}s1
# Create first image
# XXX: should use populate_slice for easier override
newfs ${NANO_NEWFS} /dev/${MD}s1a
mount /dev/${MD}s1a ${MNT}
df -i ${MNT}
echo "Copying worlddir..."
( cd ${NANO_WORLDDIR} && find . -print | cpio -dump ${MNT} )
df -i ${MNT}
echo "Generating mtree..."
( cd ${MNT} && mtree -c ) > ${NANO_OBJ}/_.mtree
( cd ${MNT} && du -k ) > ${NANO_OBJ}/_.du
umount ${MNT}
if [ $NANO_IMAGES -gt 1 -a $NANO_INIT_IMG2 -gt 0 ] ; then
# Duplicate to second image (if present)
echo "Duplicating to second image..."
dd if=/dev/${MD}s1 of=/dev/${MD}s2 bs=64k
mount /dev/${MD}s2a ${MNT}
for f in ${MNT}/etc/fstab ${MNT}/conf/base/etc/fstab
do
sed -i "" "s=${NANO_DRIVE}s1=${NANO_DRIVE}s2=g" $f
done
umount ${MNT}
fi
# Create Config slice
populate_cfg_slice /dev/${MD}s3 "${NANO_CFGDIR}" ${MNT}
# Create Data slice, if any.
if [ $NANO_DATASIZE -ne 0 ] ; then
populate_data_slice /dev/${MD}s4 "${NANO_DATADIR}" ${MNT}
fi
if [ "${NANO_MD_BACKING}" = "swap" ] ; then
echo "Writing out ${NANO_IMGNAME}..."
dd if=/dev/${MD} of=${IMG} bs=64k
fi
echo "Writing out _.disk.image..."
dd if=/dev/${MD}s1 of=${NANO_DISKIMGDIR}/_.disk.image bs=64k
mdconfig -d -u $MD
trap - 1 2 15 EXIT
) > ${NANO_OBJ}/_.di 2>&1
)
# i386 and amd64 are identical for disk images
create_amd64_diskimage ( ) (
create_i386_diskimage
)
last_orders () (
# Redefine this function with any last orders you may have
# after the build completed, for instance to copy the finished
# image to a more convenient place:
# cp ${NANO_DISKIMGDIR}/_.disk.image /home/ftp/pub/nanobsd.disk
)
#######################################################################
#
# Optional convenience functions.
#
#######################################################################
#######################################################################
# Common Flash device geometries
#
FlashDevice () {
if [ -d ${NANO_TOOLS} ] ; then
. ${NANO_TOOLS}/FlashDevice.sub
else
. ${NANO_SRC}/${NANO_TOOLS}/FlashDevice.sub
fi
sub_FlashDevice $1 $2
}
#######################################################################
# USB device geometries
#
# Usage:
#UsbDevice Generic 1000# a generic flash key sold as having 1GB
#
# This function will set NANO_MEDIASIZE, NANO_HEADS and NANO_SECTS for you.
#
# Note that the capacity of a flash key is usually advertised in MB or
# GB, *not* MiB/GiB. As such, the precise number of cylinders available
# for C/H/S geometry may vary depending on the actual flash geometry.
#
# The following generic device layouts are understood:
# generic An alias for generic-hdd.
# generic-hdd 255H 63S/T xxxxC with no MBR restrictions.
# generic-fdd 64H 32S/T xxxxC with no MBR restrictions.
#
# The generic-hdd device is preferred for flash devices larger than 1GB.
#
UsbDevice () {
a1=`echo $1 | tr '[:upper:]' '[:lower:]'`
case $a1 in
generic-fdd)
NANO_HEADS=64
NANO_SECTS=32
NANO_MEDIASIZE=$(( $2 * 1000 * 1000 / 512 ))
;;
generic|generic-hdd)
NANO_HEADS=255
NANO_SECTS=63
NANO_MEDIASIZE=$(( $2 * 1000 * 1000 / 512 ))
;;
*)
echo "Unknown USB flash device"
exit 2
;;
esac
}
#######################################################################
# Setup serial console
cust_comconsole () (
# Enable getty on console
sed -i "" -e /tty[du]0/s/off/on/ ${NANO_WORLDDIR}/etc/ttys
# Disable getty on syscons devices
sed -i "" -e '/^ttyv[0-8]/s/on/off/' ${NANO_WORLDDIR}/etc/ttys
# Tell loader to use serial console early.
echo "${NANO_BOOT2CFG}" > ${NANO_WORLDDIR}/boot.config
)
#######################################################################
# Allow root login via ssh
cust_allow_ssh_root () (
sed -i "" -e '/PermitRootLogin/s/.*/PermitRootLogin yes/' \
${NANO_WORLDDIR}/etc/ssh/sshd_config
)
#######################################################################
# Install the stuff under ./Files
cust_install_files () (
cd ${NANO_TOOLS}/Files
find . -print | grep -Ev '/(CVS|\.svn)' | cpio -dumpv ${NANO_WORLDDIR}
)
cust_clean () (
#for i in ${DIRs}; do
#echo "removing "$i" from source tree"
#rm -rf ${NANO_WORLDDIR}$i
#cd ${NANO_WORLDDIR}$i
#echo "\done"
#done
# Compress the kernel (save 3Mb)
if [ -f ${NANO_WORLDDIR}/boot/kernel/kernel ]; then
if ! gzip -v9 ${NANO_WORLDDIR}/boot/kernel/kernel; then
echo "Error during zipping the kernel"
fi
fi
# Remove some of the folders (without share/snmp)
# usr/include : 15MB
FOLDERS_TO_REMOVE='
usr/local/include
usr/local/man
usr/local/info
usr/local/share/doc/gettext
usr/local/share/doc/libasprintf
usr/local/share/doc/libiconv
usr/local/share/doc/snmp
usr/local/share/examples/quagga
usr/include
usr/share/groff_font
usr/share/tmac
usr/share/me
usr/share/info
usr/share/man
usr/share/openssl
usr/libdata/lint
usr/libdata/ldscripts
'
for c in $FOLDERS_TO_REMOVE
do
if [ -d ${NANO_WORLDDIR}/$c ]
then
echo "Removing ${NANO_WORLDDIR}/$c"
if ! rm -rf ${NANO_WORLDDIR}/$c ; then
echo "Error: Can't remove it!"
fi
fi
done
# Remove some files
FILES_TO_REMOVE='
usr/local/etc/rc.d/freevrrpd.sh.sample
usr/share/misc/magic.mgc
usr/share/misc/termcap.db
'
for c in ${FILES_TO_REMOVE}
do
if [ -f ${NANO_WORLDDIR}/$c ]
then
echo "Removing ${NANO_WORLDDIR}/$c"
if ! rm -rf ${NANO_WORLDDIR}/$c ; then
echo "Error: Can't remove it!"
fi
fi
done
# All ports are compiled, then we can remove all TOOLCHAIN files
# This save about 25MB.
# The list of these files was generated by a the output of:
# usr/src/tools/tools/build_option_survey
# Because it's a very time consuming script, output are online:
# http://phk.freebsd.dk/misc/build_options_stable_8_210741/
TOOLCHAIN_TO_REMOVE='
usr/bin/addr2line
usr/bin/gnu-ar
usr/bin/as
usr/bin/ld
usr/bin/nm
usr/bin/objcopy
usr/bin/objdump
usr/bin/gnu-ranlib
usr/bin/readelf
usr/bin/size
usr/bin/strings
usr/bin/strip
usr/bin/cc
usr/bin/gcc
usr/bin/cpp
usr/bin/c++
usr/bin/g++
usr/bin/CC
usr/bin/c++filt
usr/bin/gcov
usr/bin/gdb
usr/bin/gdbtui
usr/bin/kgdb
usr/bin/ar
usr/bin/ranlib
usr/bin/c89
usr/bin/c99
usr/bin/sum
usr/bin/compile_et
usr/bin/ctags
usr/bin/file2c
usr/bin/gprof
usr/bin/od
usr/bin/indent
usr/bin/m4
usr/bin/lex
usr/bin/lex++
usr/bin/flex
usr/bin/flex++
usr/bin/mt
usr/bin/mkstr
usr/bin/rpcgen
usr/bin/unifdef
usr/bin/unifdefall
usr/bin/nvi
usr/bin/vgrind
usr/bin/lint
usr/bin/xstr
usr/bin/lzdec
usr/bin/yacc
usr/bin/yyfix
usr/bin/byacc
usr/bin/lzdec
usr/bin/clang
usr/bin/clang++
usr/bin/clang-cpp
usr/bin/clang-tblgen
usr/bin/tblgen
usr/bin/crunchgen
usr/bin/crunchide
usr/libexec/cc1
usr/libexec/cc1plus
usr/libexec/cc1obj
usr/libexec/vfontedpr
usr/libexec/lint1
usr/libexec/lint2
usr/sbin/btxld
usr/sbin/config
usr/sbin/i2c
usr/sbin/pkg_add
usr/sbin/pkg_create
usr/sbin/pkg_delete
usr/sbin/pkg_info
usr/sbin/pkg_updating
usr/sbin/pkg_version
usr/sbin/rmt
usr/share/misc/gprof.flat
usr/share/misc/gprof.callg
usr/share/misc/vgrindefs
usr/share/misc/vgrindefs.db
'
#usr/share/tmac/tmac.vgrind
for c in $TOOLCHAIN_TO_REMOVE
do
if [ -f ${NANO_WORLDDIR}/$c ]
then
echo "Removing ${NANO_WORLDDIR}/$c"
if ! rm -rf ${NANO_WORLDDIR}/$c ; then
echo "Error: Can't remove it!"
fi
fi
done
# Move termcap.small file
if [ -f ${NANO_WORLDDIR}/etc/termcap.small ]; then
mv ${NANO_WORLDDIR}/etc/termcap.small ${NANO_WORLDDIR}/usr/share/misc/termcap.db
fi
# Kill all .a's that are installed with TOOLCHAIN (remove 33MB)
find ${NANO_WORLDDIR} -name \*.a | xargs rm
# strip binaries for ports (tips from FreeNAS 8)
pprint 4 "Stripping binaries and libraries"
for dir in $(find ${NANO_WORLDDIR}/ -name '*bin' -or -name 'lib' -maxdepth 3); do
for f in $(find $dir -type f); do
strip 2>/dev/null $f || :
done
done
# Generate package inventory
#chroot ${NANO_WORLDDIR} /bin/sh -exc \
#'pkg info' > ${NANO_OBJ}/packages.info
)
#######################################################################
# Install packages from ${NANO_PACKAGE_DIR}
cust_pkg () (
# Copy packages into chroot
mkdir -p ${NANO_WORLDDIR}/Pkg
(
cd ${NANO_PACKAGE_DIR}
find ${NANO_PACKAGE_LIST} -print |
cpio -dumpv ${NANO_WORLDDIR}/Pkg
)
# Count & report how many we have to install
todo=`ls ${NANO_WORLDDIR}/Pkg | wc -l`
echo "=== TODO: $todo"
ls ${NANO_WORLDDIR}/Pkg
echo "==="
while true
do
# Record how many we have now
have=`ls ${NANO_WORLDDIR}/var/db/pkg | wc -l`
# Attempt to install more packages
# ...but no more than 200 at a time due to pkg_add's internal
# limitations.
chroot ${NANO_WORLDDIR} sh -c \
'ls Pkg/*tbz | xargs -n 200 pkg_add -F' || true
# See what that got us
now=`ls ${NANO_WORLDDIR}/var/db/pkg | wc -l`
echo "=== NOW $now"
ls ${NANO_WORLDDIR}/var/db/pkg
echo "==="
if [ $now -eq $todo ] ; then
echo "DONE $now packages"
break
elif [ $now -eq $have ] ; then
echo "FAILED: Nothing happened on this pass"
exit 2
fi
done
rm -rf ${NANO_WORLDDIR}/Pkg
)
#######################################################################
# Convenience function:
# Register all args as customize function.
customize_cmd () {
NANO_CUSTOMIZE="$NANO_CUSTOMIZE $*"
cust_clean
}
#######################################################################
# Convenience function:
# Register all args as late customize function to run just before
#image creation.
late_customize_cmd () {
NANO_LATE_CUSTOMIZE="$NANO_LATE_CUSTOMIZE $*"
}
#######################################################################
#
# All set up to go...
#
#######################################################################
# Progress Print
#Print $2 at level $1.
pprint() {
if [ "$1" -le $PPLEVEL ]; then
runtime=$(( `date +%s` - $NANO_STARTTIME ))
printf "%s %.${1}s %s\n" "`date -u -r $runtime +%H:%M:%S`" "#####" "$2" 1>&3
fi
}
usage () {
(
echo "Usage: $0 [-biknqvw] [-c config_file]"
echo "-bsuppress builds (both kernel and world)"
echo "-isuppress disk image build"
echo "-ksuppress buildkernel"
echo "-nadd -DNO_CLEAN to buildworld, buildkernel, etc"
echo "-qmake output more quiet"
echo "-vmake output more verbose"
echo "-wsuppress buildworld"
echo "-cspecify config file"
) 1>&2
exit 2
}
#######################################################################
# Parse arguments
do_clean=true
do_kernel=true
do_world=true
do_image=true
set +e
args=`getopt bc:hiknqvw $*`
if [ $? -ne 0 ] ; then
usage
exit 2
fi
set -e
set -- $args
for i
do
case "$i"
in
-b)
do_world=false
do_kernel=false
shift
;;
-k)
do_kernel=false
shift
;;
-c)
. "$2"
shift
shift
;;
-h)
usage
;;
-i)
do_image=false
shift
;;
-n)
do_clean=false
shift
;;
-q)
PPLEVEL=$(($PPLEVEL - 1))
shift
;;
-v)
PPLEVEL=$(($PPLEVEL + 1))
shift
;;
-w)
do_world=false
shift
;;
--)
shift
break
esac
done
if [ $# -gt 0 ] ; then
echo "$0: Extraneous arguments supplied"
usage
fi
#######################################################################
# Setup and Export Internal variables
#
test -n "${NANO_OBJ}" || NANO_OBJ=/usr/obj/nanobsd.${NANO_NAME}/
test -n "${MAKEOBJDIRPREFIX}" || MAKEOBJDIRPREFIX=${NANO_OBJ}
test -n "${NANO_DISKIMGDIR}" || NANO_DISKIMGDIR=${NANO_OBJ}
NANO_WORLDDIR=${NANO_OBJ}/_.w
NANO_MAKE_CONF_BUILD=${MAKEOBJDIRPREFIX}/make.conf.build
NANO_MAKE_CONF_INSTALL=${NANO_OBJ}/make.conf.install
if [ -d ${NANO_TOOLS} ] ; then
true
elif [ -d ${NANO_SRC}/${NANO_TOOLS} ] ; then
NANO_TOOLS=${NANO_SRC}/${NANO_TOOLS}
else
echo "NANO_TOOLS directory does not exist" 1>&2
exit 1
fi
if $do_clean ; then
true
else
NANO_PMAKE="${NANO_PMAKE} -DNO_CLEAN"
fi
export MAKEOBJDIRPREFIX
export NANO_ARCH
export NANO_CODESIZE
export NANO_CONFSIZE
export NANO_CUSTOMIZE
export NANO_DATASIZE
export NANO_DRIVE
export NANO_HEADS
export NANO_IMAGES
export NANO_IMGNAME
export NANO_MAKE_CONF_BUILD
export NANO_MAKE_CONF_INSTALL
export NANO_MEDIASIZE
export NANO_NAME
export NANO_NEWFS
export NANO_OBJ
export NANO_PMAKE
export NANO_SECTS
export NANO_SRC
export NANO_TOOLS
export NANO_WORLDDIR
export NANO_BOOT0CFG
export NANO_BOOTLOADER
#######################################################################
# And then it is as simple as that...
# File descriptor 3 is used for logging output, see pprint
exec 3>&1
NANO_STARTTIME=`date +%s`
pprint 1 "NanoBSD image ${NANO_NAME} build starting"
if $do_world ; then
if $do_clean ; then
clean_build
else
pprint 2 "Using existing build tree (as instructed)"
fi
make_conf_build
build_world
else
pprint 2 "Skipping buildworld (as instructed)"
fi
if $do_kernel ; then
build_kernel
else
pprint 2 "Skipping buildkernel (as instructed)"
fi
clean_world
make_conf_install
install_world
install_etc
setup_nanobsd_etc
install_kernel
run_customize
setup_nanobsd
prune_usr
run_late_customize
if $do_image ; then
create_${NANO_ARCH}_diskimage
else
pprint 2 "Skipping image build (as instructed)"
fi
last_orders
pprint 1 "NanoBSD image ${NANO_NAME} completed"
##################################################################################################################################
>>Never change variables inside nanobsd.sh, create a config file instead
>>and the run "sh nanobsd.sh -c configfile.conf"
Thanks for your suggestion, i will do so :)
I want to use both vga console and serial console, Is it possible ?
More information about the freebsd-embedded
mailing list